
; audio pitch shift demo for OLIMEX PIC-USB-STK ( http://www.olimex.com/dev/pic-usb-stk.html )
; RA0 (pin 2) - potentiometer
; RA5 (pin 7) - audio in
; RC1 (pin 16) - PWM audio out
; LEDs:
; RD0 (pin 19) - sample clock
; RD1 (pin 20) - write buffer position
; RD2 (pin 21) - read buffer position
; RD3 (pin 22) - audio input overload

; 25 ksps, buffer 10 ms

; pfgx@yandex.ru
; 2012/06/17

            LIST        P=18F4550
            #INCLUDE    <P18F4550.INC>

;  CONFIG1L            
            CONFIG      USBDIV = 2
            CONFIG      CPUDIV = OSC1_PLL2
            CONFIG      PLLDIV = 5
;  CONFIG1H            
            CONFIG      IESO = OFF
            CONFIG      FCMEN = OFF
            CONFIG      FOSC = HSPLL_HS
;  CONFIG2L            
            CONFIG      VREGEN = ON
            CONFIG      BORV = 3
            CONFIG      BOR = ON
            CONFIG      PWRT = ON
;  CONFIG2H            
            CONFIG      WDTPS = 32768
            CONFIG      WDT = OFF
;  CONFIG3L
            ;  .
;  CONFIG3H            
            CONFIG      MCLRE = ON
            CONFIG      LPT1OSC = OFF
            CONFIG      PBADEN = OFF
            CONFIG      CCP2MX = ON
;  CONFIG4L            
            CONFIG      DEBUG = OFF
            CONFIG      XINST = OFF
            CONFIG      ICPRT = OFF
            CONFIG      LVP = OFF
            CONFIG      STVREN = ON
;  CONFIG4H
            ; .
;  CONFIG5L
            CONFIG      CP3 = OFF
            CONFIG      CP2 = OFF
            CONFIG      CP1 = OFF
            CONFIG      CP0 = OFF
;  CONFIG5H            
            CONFIG      CPD = OFF
            CONFIG      CPB = OFF
;  CONFIG6L            
            CONFIG      WRT3 = OFF
            CONFIG      WRT2 = OFF
            CONFIG      WRT1 = OFF
            CONFIG      WRT0 = OFF
;  CONFIG6H            
            CONFIG      WRTD = OFF
            CONFIG      WRTB = OFF
            CONFIG      WRTC = OFF
;  CONFIG7L            
            CONFIG      EBTR3 = OFF
            CONFIG      EBTR2 = OFF
            CONFIG      EBTR1 = OFF
            CONFIG      EBTR0 = OFF
;  CONFIG7H            
            CONFIG      EBTRB = OFF

readpos equ 0x10
writepos equ 0x12
outdata equ 0x13
playspeed equ 0x14
indata equ 0x15

	org 0
	goto _main
	
	org 0x0008
	goto $
	
	org 0x0018
	goto $
	
_main:
	; PORTD init
	movlw 0x00
	movwf TRISD
	
	; ADC init	
	bsf ADCON0,0	
	movlw 0x3f
	movwf ADCON2
	
	; CCP2 PWM mode
	bsf CCP2CON,2
	bsf CCP2CON,3	
	bsf T2CON,2
	bcf TRISC,1 ; CCP2 out
	
_loop:
	
	; read MIC IN
	bcf ADCON0,2
	bcf ADCON0,3
	bsf ADCON0,4
	bcf ADCON0,5
	bsf ADCON0,1 ; start
	btfsc ADCON0,1 ; wait
	goto $-2

	movf ADRESH,0
	movwf indata

	; LED's
	bsf LATD,0
	
	btfsc writepos,7
	bsf LATD,1
	btfss writepos,7
	bcf LATD,1

	btfsc readpos,7
	bsf LATD,2
	btfss readpos,7
	bcf LATD,2

	bcf LATD,3
	movf indata,0
	andlw 0x7f
	btfss indata,7
	xorlw 0x7f
	addlw 0x90
	btfsc STATUS,C
	bsf LATD,3
	
	bcf LATD,0
	; LED's end

	; read from buffer to "outdata"
	movlw 0x01
	movwf FSR0H
	movf readpos,0
	movwf FSR0L	
	movf INDF0,0
	movwf outdata

	; write "indata" to buffer
	movlw 0x01
	movwf FSR0H
	movf writepos,0
	movwf FSR0L
	movf indata,0
	movwf INDF0
	
	; write audio to PWM
	movf outdata,0
	movwf CCPR2L
	
	; recalc buffer pointer positions
	movf playspeed,0
	addwf readpos+1,1
	btfsc STATUS,C
	incf readpos,1
	;
	movlw 0x80
	addwf readpos+1,1
	btfsc STATUS,C
	incf readpos,1
	;
	incfsz writepos,1
	goto _loop


	; read potentiometer
	bcf ADCON0,2
	bcf ADCON0,3
	bcf ADCON0,4
	bcf ADCON0,5
	bsf ADCON0,1 ; start
	btfsc ADCON0,1 ; wait
	goto $-2
	
	movf ADRESH,0
	movwf playspeed	
	
	goto _loop
	

	end
	
	